#ifndef _INCLUDE_DRAW_SURFACE_H_
#define _INCLUDE_DRAW_SURFACE_H_

/* 
Jumping Jack by Stanislav Tihohod 
Copyright (c) 2002 by Stanislav Tihohod. 
*/

//  CDrawSurface   .   
// ,      (m_GraphObjectsAttached).

#include "Area.h"
#include "ScrObjHolder.h"

const int MAX_INVALID_RECT=25; //     

class CDrawSurface
{
private:

	WinHandle m_hSurfHandle;
	RectangleType m_Bounds;
	
	int m_NFreshAreas;
	CArea m_FreshArea[MAX_INVALID_RECT];
	
	CScreenObjectHolder m_GraphObjectsAttached;
	
public:

	void attachObject(CScreenObject *pScreenObject); 
	void detachObject(CScreenObject *pScreenObject);
	
public:

	void eraseFreshAreas();
	void clearFreshList();
	void addFreshArea(const CArea& NewArea);
	void addFreshArea(const RectangleType& NewRect);
	void clear(void);
	
public:

	WinHandle getSurfaceHandle(void) {return m_hSurfHandle;}
	
public:

	void drawObjects(void);
	
public:

	void create(int cx, int cy, bool bOffscreen=true);
	void flip(CDrawSurface &dstSurf, int xpos, int ypos);	
	
public:

	CDrawSurface();
};

#endif